# RBTorsionForce Class Reference

This class implements an interaction between groups of four particles that varies with the torsion angle between them according to the Ryckaert-Bellemans potential. More...

`#include <RBTorsionForce.h>`

Inheritance diagram for RBTorsionForce:

List of all members.

## Classes

class | RBTorsionInfo
| This is an internal class used to record information about a torsion.

## Public Member Functions

| RBTorsionForce ()
| Create a RBTorsionForce.
int | getNumTorsions () const
| Get the number of Ryckaert-Bellemans torsion terms in the potential function.
int | addTorsion (int particle1, int particle2, int particle3, int particle4, double c0, double c1, double c2, double c3, double c4, double c5)
| Add a Ryckaert-Bellemans torsion term to the force field.
void | getTorsionParameters (int index, int &particle1, int &particle2, int &particle3, int &particle4, double &c0, double &c1, double &c2, double &c3, double &c4, double &c5) const
| Get the force field parameters for a Ryckaert-Bellemans torsion term.
void | setTorsionParameters (int index, int particle1, int particle2, int particle3, int particle4, double c0, double c1, double c2, double c3, double c4, double c5)
| Set the force field parameters for a Ryckaert-Bellemans torsion term.
void | updateParametersInContext (Context &context)
| Update the per-torsion parameters in a Context to match those stored in this Force object.

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class implements an interaction between groups of four particles that varies with the torsion angle between them according to the Ryckaert-Bellemans potential.

To use it, create an RBTorsionForce object then call addTorsion() once for each torsion. After a torsion has been added, you can modify its force field parameters by calling setTorsionParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

RBTorsionForce | ( |  | ) |

Create a RBTorsionForce.

## Member Function Documentation

int addTorsion | ( | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | double | c0,
|  | double | c1,
|  | double | c2,
|  | double | c3,
|  | double | c4,
|  | double | c5 |
| ) |  |  |

Add a Ryckaert-Bellemans torsion term to the force field.

Parameters:

  | particle1 | the index of the first particle forming the torsion
  | particle2 | the index of the second particle forming the torsion
  | particle3 | the index of the third particle forming the torsion
  | particle4 | the index of the fourth particle forming the torsion
  | c0 | the coefficient of the constant term, measured in kJ/mol
  | c1 | the coefficient of the 1st order term, measured in kJ/mol
  | c2 | the coefficient of the 2nd order term, measured in kJ/mol
  | c3 | the coefficient of the 3rd order term, measured in kJ/mol
  | c4 | the coefficient of the 4th order term, measured in kJ/mol
  | c5 | the coefficient of the 5th order term, measured in kJ/mol

Returns:
  the index of the torsion that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

int getNumTorsions | ( |  | ) | const`[inline]`

Get the number of Ryckaert-Bellemans torsion terms in the potential function.

void getTorsionParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | int & | particle3,
|  | int & | particle4,
|  | double & | c0,
|  | double & | c1,
|  | double & | c2,
|  | double & | c3,
|  | double & | c4,
|  | double & | c5 |
| ) |  |  | const

Get the force field parameters for a Ryckaert-Bellemans torsion term.

Parameters:

  | index | the index of the torsion for which to get parameters
  | particle1 | the index of the first particle forming the torsion
  | particle2 | the index of the second particle forming the torsion
  | particle3 | the index of the third particle forming the torsion
  | particle4 | the index of the fourth particle forming the torsion
  | c0 | the coefficient of the constant term, measured in kJ/mol
  | c1 | the coefficient of the 1st order term, measured in kJ/mol
  | c2 | the coefficient of the 2nd order term, measured in kJ/mol
  | c3 | the coefficient of the 3rd order term, measured in kJ/mol
  | c4 | the coefficient of the 4th order term, measured in kJ/mol
  | c5 | the coefficient of the 5th order term, measured in kJ/mol

void setTorsionParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | double | c0,
|  | double | c1,
|  | double | c2,
|  | double | c3,
|  | double | c4,
|  | double | c5 |
| ) |  |  |

Set the force field parameters for a Ryckaert-Bellemans torsion term.

Parameters:

  | index | the index of the torsion for which to set parameters
  | particle1 | the index of the first particle forming the torsion
  | particle2 | the index of the second particle forming the torsion
  | particle3 | the index of the third particle forming the torsion
  | particle4 | the index of the fourth particle forming the torsion
  | c0 | the coefficient of the constant term, measured in kJ/mol
  | c1 | the coefficient of the 1st order term, measured in kJ/mol
  | c2 | the coefficient of the 2nd order term, measured in kJ/mol
  | c3 | the coefficient of the 3rd order term, measured in kJ/mol
  | c4 | the coefficient of the 4th order term, measured in kJ/mol
  | c5 | the coefficient of the 5th order term, measured in kJ/mol

void updateParametersInContext | ( | Context & | context | ) |

Update the per-torsion parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setTorsionParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

The only information this method updates is the values of per-torsion parameters. The set of particles involved in a torsion cannot be changed, nor can new torsions be added.

The documentation for this class was generated from the following file:

- RBTorsionForce.h